﻿\>bzminer --help

BzMiner - Advanced Crypto Miner

Usage: bzminer [OPTIONS]

Options:

- h,--help                   Print this help message and exit

--version                   Get the version of this binary

--lang TEXT                 Set the language (en, cn). Default en

- a TEXT                     Default Mining algorithm. eg. 'ethash'

--a2 TEXT                   Default second Mining algorithm (dual mine). eg. 'ethash'

--a3 TEXT                   Default third Mining algorithm (tri mine, also zil + dual). eg. 'zil'

- r TEXT                     Default Rig (worker/username) name. eg. 'Rig'

--r2 TEXT                   Default Pool username for second algo (dual mine)

--r3 TEXT                   Default Pool username for third algo (tri mine, also zil + dual)

--temp\_stop INT             Temperature to pause mining on a device (should be higher than temp\_start)

--temp\_start INT            Temperature to start mining on a device again (should be lower than temp\_stop)

--pool\_password TEXT        Default Pool password

--pool\_password2 TEXT       Default Pool password for second algo (dual mine)

--pool\_password3 TEXT       Default Pool password for second algo (dual mine)

--igpu BOOLEAN              Enable IGPU (0 = false, 1 = true, default 0)

--nvidia INT                Mine with Nvidia devices (0 = false, 1 = true, 1 is default)

--amd INT                   Mine with AMD devices (0 = false, 1 = true, 1 is default)

--intel INT                 Mine with Intel devices (0 = false, 1 = true, 1 is default)

--cpu INT                   Mine with CPU (0 = false, 1 = true, 0 is default). Certain algos such as warthog will automatically enable cpu devices

--disable\_cpu\_metrics       Disable cpu metrics. cpu metrics can have a small overhead, also if crashing early try setting this to 1. default is 1

--disable\_opencl            Disable OpenCL. Useful for BzMiner crashing during startup due to AMD drivers.

--nvidia\_opencl             Enable Nvidia opencl device enumeration

- w TEXT ...                 Wallet Address. If algorithm requires more than one address, list them same as -p

--w2 TEXT ...               Wallet Address for second algo (dual mine). If algorithm requires more than one address, list them same as -p

--w3 TEXT ...               Wallet Address for third algo (tri mine, also zil + dual). If algorithm requires more than one address, list them same as -p

- p TEXT ...                 Array of Pool Addresses. eg. stratum+tcp://us1.ethermine.org:4444  stratum+tcp://us2.ethermine.org:4444

--p2 TEXT ...               Array of Pool Addresses for second algo (dual mine). eg. stratum+tcp://us1.ethermine.org:4444  stratum+tcp://us2.ethermine.org:4444

--p3 TEXT ...               Array of Pool Addresses for third algo (tri mine, also zil + dual). eg. zmp+tcp://zil.flexpool:4444 ethproxy+tcp://us-east.ezil.me:5555

- v INT                      Set log verbosity. 0 = Error, 1 = warn, 2 = info 3 = debug, 4 = network

--hide\_disabled\_devices     Do not log devices that are disabled.

--max\_log\_history INT       For http api. max retained log history. default is 1024. Higher values increase memory usage.

--log\_solutions INT         If 1 (default 1), Solutions will be logged in output (as green).

--log\_date INT              If 1 (default 0), the current date/time will be logged at the start of every line of output.

--immediate\_log             If specified, logger will immediately output logs. This can have a small impact on performance.

--log\_frequency\_ms INT      Log frequency in milliseconds. Default is 500.

- o TEXT                     If provided, output will be logged to this file

--log\_file\_verbosity INT    Set log file verbosity. Default 2.

--clear\_log\_file INT        If 1 (default 0), BzMiner will overwrite the log file on start.

- c TEXT                     Config file to load settings from. Default is config.txt
- i INT                      Set mining intensity (0 - 64). 0 = auto. Higher means more gpu spends more time hashing. Default is 0.

--i1 INT                    Set mining intensity (0 - 64). 0 = auto. Higher means more gpu spends more time hashing. Default is 0.

--i2 INT                    Set mining intensity for second algo (dual mine) (0 - 64). 0 = auto. Higher means more gpu spends more time hashing. Default is 0.

--i3 INT                    Set mining intensity for third algo (tri mine, also zil + dual) (0 - 64). 0 = auto. Higher means more gpu spends more time hashing. Default is 0.

--ssl\_verify BOOLEAN        Verify SSL certs when set to 1. Default is 0.

--lhr\_stability INT ...     Set the LHR Unlock Stability value for each device. Lower is more stable, higher is less stable and higher hashrate. Default is 100.

--lhr\_exception\_reboot      Reboot the pc when an LHR exception happens on a device (device hard reset currently requires pc reboot).

--allow\_stales BOOLEAN      If 0 (default 1), BzMiner will prevent stales from being sent to the pool.

--restart\_on\_disconnect BOOLEAN

If 1 (default 0), BzMiner will restart when a pool unexpectedly disconnects. Can be useful when having issues on auto reconnects.

--throttle INT ...          Throttle mining on pool 1 (array of devices, or just one value to set all to same). default is 0.

--throttle1 INT ...         Throttle mining on pool 1 (array of devices, or just one value to set all to same). default is 0.

--throttle2 INT ...         Throttle mining on pool 2 (array of devices, or just one value to set all to same). default is 0.

--throttle3 INT ...         Throttle mining on pool 3 (array of devices, or just one value to set all to same). default is 0.

--mem\_on\_demand INT ...     An array of devices that should allocate memory (luts, dags) only when they are needed, then releasing that memory after they are no longer needed. Useful for cards that cannot hold two algos memory allocations at the same time such as nexa + zil on 8gb cards. Default is 0

- g INT                      Ramp up miner rather than start at full speed.
- b INT                      Cooldown period. 0 = disabled. Higher value means longer time between cooldown periods. default is 0

--repair\_dag INT            Validate and repair DAG. Default is 1

--nc INT                    Do not save to the config file (but still read from it).

--show\_pending              Do not start watchdog service.

--update\_frequency\_ms INT   Output frequency in milliseconds. 0 = disabled. Default is 15000.

--update\_frequency\_shares INT

Output frequency based on new shares found. 0 = disabled. Does not replace update\_frequency\_ms, works in parallel. set update\_frequency\_ms to 0 if you only want to use update\_frequency\_shares. Default is 0.

--avg\_hr\_ms INT             Hashrate averaging window. Longer is more stable hashrate reporting. Default is 30000.

--reset\_pool\_hr\_ms UINT     Reset the Pool hr column after milliseconds. Default is 3600000. Set to 0 to disable reset.

--disable\_index\_html        Disable creating index.html file

--extra\_dev\_fee FLOAT       Add a little extra time for dev fee (percentage). Adds to default dev fee. Default 0.0

--cpu\_validate INT          Validate solutions on cpu before sending to pool.

--multi\_mine\_ms INT ...     Time (ms) to mine each algo when dual mining.

--multi\_mine\_type INT ...   Multi mine type. 0 = parallel, 1 = alternating (can oc per algo), 2 = mine only during DAG generation. default = 0

--max\_dual\_autotune\_drop FLOAT

Max hashrate drop of first algo in dual mining when autotuning. 0.0 - 1.0. default 0.92.

--cache\_dag INT             Useful for eth + zil. 0 = disabled (default), 1 = dag cached in vram (only supported on >6gb cards)

--zil\_only                  Only mine zil for the first algo (for zil + non-eth algo). Will set for first pool\_config. Will only generate a dag for epoch 0 (zil). use in combination with --multi\_mine\_type 1, --multi\_mine\_ms 0 10000 and cache\_dag 1

--zil\_retain\_hashrate BOOLEAN

Continue showing last zil hashrate outside the zil window. This may result in OS's showing a hashrate for zil outside the window as well

--zil\_gpus INT ...          list if gpu indexes for which cards to mine zil. If not specified, all gpus by default will mine zil.

--force\_algo TEXT           Force an algorithm to run. Useful for OS's that do not currently have the desired algo implemented in integration scripts

--force\_algo2 TEXT          Force an algorithm to run as the second algo in dual. Useful for OS's that do not currently have the desired algo implemented in integration scripts

--opencl\_workgroup\_size INT Force an opencl algorithm to use a specific workgroup size.

--community\_fund INT        Enable/Disable community fund (currently kaspa and radiant only). Value is a multiple of normal dev fee, so value of 1 = 1% donation, 2 = 2% donation, etc. Default is 1, 0 is disabled

--algo\_opt INT ...          A list (one per device) of whether to use algorithm optimizations if the algo supports it.

--test INT                  Test mine. Useful for setting up overclocks.

--testdiff INT              Test difficulty. 1 - lowest difficulty, no limit to max difficulty

--pool\_reconnect\_timeout\_ms INT

Pool reconnect timeout override in ms. default is 30000

--dynex\_cache\_mallob INT    If 0 - do not cache mallob config, If 1 - mallob will be cached to local disk in the 'cache' folder, so if miner restarts, the mallob will not need to be redownloaded. Everything in the 'cache' folder will be deleted on new mallob jobs. if 2 - same as 1 but will not clear the cache folder. Default is no caching, 1

--dynex\_test\_mallob\_file TEXT

For testing, if specified will force the use of a local mallob file instead of downloading one from the network.

--dynex\_max\_chips INT ...   Set to 0 for no limit, otherwise set to >0 for max number of chips to use per device

--dynex\_pow\_ratio FLOAT ... space separated list of 0.0 - 2.0 values (one value per gpu). default is 1.0 meaning max pouw and pow. 0.0 = do not do pow, only pouw. 2.0 = only do pow, do not do pouw (pow on rig is limited by total pouw work done). Use this option to specify some cards to do only pow and other do pouw, allowing to set better ocs per card. Read docs for examples.

--warthog\_cache\_config INT  Changes the way bz groups threads in order to maximize cache hits. Default 0 (try grouping by l3 cache). 1 = all threads in one group (per cpu). 2 is highest cache/grouping level in cpu topology. higher means more groups, 10 might mean each thread is grouped by itself if there were less than 10 groups in the cpu topology.

--warthog\_cpu\_threads INT   Number of CPU threads to use for warthog. Default = 0 (number of logical processors)

--warthog\_unused\_cpu\_offset INT

Unused processors start index. Bz will start mining on x number of processors after this offset (x being warthog\_cpu\_threads). Default is 0. If warthog\_cpu\_threads is larger than remaining processors, threads will wrap back to start of logical processor indexes on the cpu.

--warthog\_max\_ram\_gb FLOAT  Maximum amount of cpu ram (gb) to use for warthog. Default is 0. value of 0 will dynamically choose how much ram to use based on thread count. If available ram is less than requested, will use available ram minus 1gb.

--warthog\_verus\_hr\_target FLOAT ...

Target verus hashrate for each gpu. Default is 0. space separated list of hashes per second (eg. 1mh would be 1000000). Any gpu that isn't specified will use calibration

--ironfish\_graffiti TEXT    Set a custom graffiti. This is a string, max size is 32 characters. default is empty (or what pool provided)

--http\_enabled INT          Enable or disable HTTP API. 0 = disabled, 1 = enabled Default is enabled.

--http\_address TEXT         Set IP address for HTTP API to listen on. Default is 0.0.0.0.

--http\_port INT             Set which port the HTTP API listens on. default is 4014.

--http\_password TEXT        Set password for HTTP API. If not set, HTTP API will not be enabled. default is empty.

--force\_opencl INT          Force all devices to use the OpenCL implementation (if possible).

--reset\_oc\_dag\_gen INT      Reset overclocks before dag generation. Clocks will be set back after dag is generated. 1 = enabled, 0 = disabled

--devices                   Only log devices. Does not start miner

--no\_watchdog               Do not start watchdog service.

--disable TEXT ...          Disable specific GPUs from mining, separate by a space. Use device id in the format of pci\_bus:pci\_device (eg. --disable 1:0 3:0). use --devices to find device id.

--enable TEXT ...           Enable specific GPUs from mining, separate by a space. This overrides --disable. Use device id in the format of pci\_bus:pci\_device (eg. --enable 1:0 3:0). use --devices to find device id.

--advanced\_config INT       If 1 (default 0), advanced config options will be showin in config.txt.

--start\_script TEXT         If specified, this script will run when BzMiner starts.

--hung\_gpu\_ms INT           When GPU does not respond for this amount of time (ms), will be considered hung.

--crash\_script TEXT         When hung GPU is detected, this script will run.

--hung\_gpu\_reboot INT       If 1 (default 0), BzMiner will reboot the rig when a hung GPU is detected.

--hung\_gpu\_restart\_bzminer INT

If 1 (default 1), and watchdog is enabled, watchdog will restart BzMiner process when hung GPU is detected.

--reboot\_after\_watchdog\_restarts INT

Reboot PC after watchdog restarts x number of times

--restart\_miner\_minutes INT If specified and greater than 0, BzMiner watchdog will restart BzMiner process after this amount of time (minutes).

--reboot\_minutes INT        If specified and greater than 0, BzMiner will reboot the rig after this amount of time (minutes).

--no\_color INT              If 1 (default 0), output in console will not have color.

--webhook\_discord\_url TEXT  Discord webhook api url

--webhook\_discord\_solutions\_only INT

If true, only solutions will be sent to this webhook

--webhook\_discord\_interval\_ms INT

How often to send the logs to discord

--webhook\_discord\_verbosity INT

verbosity of discord web hook. default is 2

--oc\_delay\_ms INT ...       Time (ms) to delay algo switch before/after oc changed for algo. default 50.

--oc\_enable INT ...         Whether oc should be set for the first algo or not (per device). Default is 1.

--oc\_fan\_speed TEXT ...     Set the target fan speed (as percentage) for devices, separated by a space. 0 = auto, -1 = ignore, 100 = max.

Optionally use target temperature format, eg. --oc\_fan\_speed t:N[fMin-fMax]

where t is core, tm is mem , N is target temp, fMin is min fan speed percent, fMax is max fan speed percent

eg. --oc\_fan\_speed t:65[25-75] tm:85[50-100]

--oc\_power\_limit INT ...    Set the power limite for devices (in watts), separated by a space. 0 = ignore.

--oc\_core\_clock\_offset INT ...

Set the target core clock offset (in mhz) for devices, separated by a space. 0 = ignore.

--oc\_memory\_clock\_offset INT ...

Set the target memory clock offset (in mhz) for devices, separated by a space. 0 = ignore.

--oc\_core\_volt\_offset INT ...

Set the target core voltage offset (in mv) for devices, separated by a space. 0 = ignore.

--oc\_memory\_volt\_offset INT ...

Set the target memory voltage offset (in mv) for devices, separated by a space. 0 = ignore.

--oc\_lock\_core\_clock INT ...

Lock the core clock for devices (in mhz), separated by a space. Overrides oc\_core\_clock.

--oc\_lock\_memory\_clock INT ...

Lock the memory clock for devices (in mhz), separated by a space. Overrides oc\_memory\_clock.

--oc\_pstate INT ...         Force a specific pstate. default is -1, will not change pstate

--oc\_script TEXT ...        Instead of BzMiner setting oc's for a card/algo, call a script instead when oc needs to be set.

script is called with parameters --gpu\_index {gpu index} --gpu\_id {gpu id} --algo {algorithm oc is being set for}

eg.

'oc\_script.bat --gpu\_index 0 --gpu\_id 1:0 --algo kaspa`

BzMiner will call this script for each gpu that needs oc to be set. If this parameter is specified, BzMiner will not set any overclocks on it's own. Can pass an array of scripts, one for each gpu. Default is empty string

--oc\_enable2 INT ...        Whether oc should be set for the second algo or not (per device). Default is 1.

--oc\_fan\_speed2 TEXT ...    (second algo) Set the target fan speed (as percentage) for devices, separated by a space. 0 = auto, -1 = ignore, 100 = max.

Optionally use target temperature format, eg. --oc\_fan\_speed t:N[fMin-fMax]

where t is core, tm is mem , N is target temp, fMin is min fan speed percent, fMax is max fan speed percent

eg. --oc\_fan\_speed t:65[25-75] tm:85[50-100]

--oc\_power\_limit2 INT ...   (second algo) Set the power limite for devices (in watts), separated by a space. 0 = ignore.

--oc\_core\_clock\_offset2 INT ...

(second algo) Set the target core clock offset (in mhz) for devices, separated by a space. 0 = ignore.

--oc\_memory\_clock\_offset2 INT ...

(second algo) Set the target memory clock offset (in mhz) for devices, separated by a space. 0 = ignore.

--oc\_core\_volt\_offset2 INT ...

(second algo) Set the target core voltage offset (in mv) for devices, separated by a space. 0 = ignore.

--oc\_memory\_volt\_offset2 INT ...

(second algo) Set the target memory voltage offset (in mv) for devices, separated by a space. 0 = ignore.

--oc\_lock\_core\_clock2 INT ...

(second algo) Lock the core clock for devices (in mhz), separated by a space. Overrides oc\_core\_clock.

--oc\_lock\_memory\_clock2 INT ...

(second algo) Lock the memory clock for devices (in mhz), separated by a space. Overrides oc\_memory\_clock.

--oc\_pstate2 INT ...        (second algo) Force a specific pstate. default is -1, will not change pstate

--oc\_script2 TEXT ...       (second algo) Instead of BzMiner setting oc's for a card/algo, call a script instead when oc needs to be set.

script is called with parameters --gpu\_index {gpu index} --gpu\_id {gpu id} --algo {algorithm oc is being set for}

eg.

'oc\_script.bat --gpu\_index 0 --gpu\_id 1:0 --algo kaspa`

BzMiner will call this script for each gpu that needs oc to be set. If this parameter is specified, BzMiner will not set any overclocks on it's own. Can pass an array of scripts, one for each gpu. Default is empty string

--oc\_enable3 INT ...        Whether oc should be set for the third algo or not (per device). Default is 1.

--oc\_fan\_speed3 TEXT ...    (third algo) Set the target fan speed (as percentage) for devices, separated by a space. 0 = auto, -1 = ignore, 100 = max.

Optionally use target temperature format, eg. --oc\_fan\_speed t:N[fMin-fMax]

where t is core, tm is mem , N is target temp, fMin is min fan speed percent, fMax is max fan speed percent

eg. --oc\_fan\_speed t:65[25-75] tm:85[50-100]

--oc\_power\_limit3 INT ...   (third algo) Set the power limite for devices (in watts), separated by a space. 0 = ignore.

--oc\_core\_clock\_offset3 INT ...

(third algo) Set the target core clock offset (in mhz) for devices, separated by a space. 0 = ignore.

--oc\_memory\_clock\_offset3 INT ...

(third algo) Set the target memory clock offset (in mhz) for devices, separated by a space. 0 = ignore.

--oc\_core\_volt\_offset3 INT ...

(third algo) Set the target core voltage offset (in mv) for devices, separated by a space. 0 = ignore.

--oc\_memory\_volt\_offset3 INT ...

(third algo) Set the target memory voltage offset (in mv) for devices, separated by a space. 0 = ignore.

--oc\_lock\_core\_clock3 INT ...

(third algo) Lock the core clock for devices (in mhz), separated by a space. Overrides oc\_core\_clock.

--oc\_lock\_memory\_clock3 INT ...

(third algo) Lock the memory clock for devices (in mhz), separated by a space. Overrides oc\_memory\_clock.

--oc\_pstate3 INT ...        (third algo) Force a specific pstate. default is -1, will not change pstate

--oc\_script3 TEXT ...       (third algo) Instead of BzMiner setting oc's for a card/algo, call a script instead when oc needs to be set.

script is called with parameters --gpu\_index {gpu index} --gpu\_id {gpu id} --algo {algorithm oc is being set for}

eg.

'oc\_script.bat --gpu\_index 0 --gpu\_id 1:0 --algo kaspa`

BzMiner will call this script for each gpu that needs oc to be set. If this parameter is specified, BzMiner will not set any overclocks on it's own. Can pass an array of scripts, one for each gpu. Default is empty string

--oc\_mem\_tweak INT          gddr5x memory tweak. 0-4, 0 = disabled, 1-4 = timing, higher = faster. May need to reduce overclocks.

--oc\_unlock\_clocks          Unlock the core and memory clocks. Will not mine (same as --devices argument).

--oc\_reset\_all              Completely reset oc on all devices. Requires admin/root

--oc\_reset\_on\_exit INT      Reset overclocks on bzminer exit. default 1 (enable), 0 = disable
